dist = @(x) [1 x(1); 0 1];                    % distance
lens = @(f) [1 0; -1/f 1];              %focal length

% a telescope
telescope = @(f1,f2,L) lens(f2)*dist(L)*lens(f1);

% transformation equation
qNew = @(q,ABCD) (q*ABCD(1,1)+ABCD(1,2)) / (q*ABCD(2,1)+ABCD(2,2));



qIn = waist2q(1.84e-3,0);    % An ideal input beam
qIn_v = -5+10i;             % Astigmatic vertical
qIn_h =  5+10i;              % Astigmatic horizontal
F1 = 0.344;                 % lens 1
F2 = -0.143;                % lens 2
lambda = 1.064e-6;          % Nd:YAG

telLength = 0.229;


gouyDiff = @(zQPD1, zQPD2, qin) ...
    ( angle(qNew(qin, telescope(F1,F2,telLength))+zQPD1 ) - ...
      angle(qNew(qin, telescope(F1,F2,telLength))+zQPD2 ) ) * 180/pi;
  
matchFunc = @(x) abs(gouyDiff(x(1), x(2), qIn_v) - ...
                     gouyDiff(x(1), x(2), qIn_h));
                 
gouyMatch = fminsearch(matchFunc, [0.2 0.6])
gouyDiff(gouyMatch(1), gouyMatch(2), qIn_v)
gouyDiff(gouyMatch(1), gouyMatch(2), qIn_h)
